var scr = "[obj_fx_glow:Step] ";

 if (do_destroy)
  {
    instance_destroy();
    do_destroy = false;
	//exit;
  }; // end of do_destroy

  if (do_init)
  {
     if (do_make_visible)
     {
        visible = true;
     }
     
     duration = abs(duration);
     color_duration = duration;
     fade_duration  = duration;
     scale_duration = duration;
          
     // scale from actual sprite
     local_width  = sprite_get_width(sprite);
     local_height = sprite_get_height(sprite);
     
     // scaling factor to multiply with
     scale_base_x = width  / local_width;
     scale_base_y = height / local_height;
     
     scale_x = scale_x_start;
     scale_y = scale_y_start;
     
     if (!is_static && (scale_x_end != scale_x_start))
     {
         do_animate_scale = true;      
         
         if (scale_duration > 0)
         {
            scale_x_step = max(scale_x_start, scale_x_end) / scale_duration;
            scale_y_step = max(scale_y_start, scale_y_end) / scale_duration;
         }
         else
         {
            scale_x_step = 0;
            scale_y_step = 0;
         }
         
         if (scale_x_start < scale_x_end)
         {
            is_scale_up = true;
         }
         else
         {
            is_scale_up = false;
         }
     }
     
     // alpha
     alpha = alpha_start;
     if (!is_static && (alpha_start != alpha_end))
     {
        do_animate_alpha = true;
        
        if (fade_duration > 0)
        {
            alpha_step = max(alpha_start, alpha_end) / fade_duration;
        }
        else
        {
            alpha_step = 0;
        }
        
        if (alpha_start < alpha_end)
        {
            is_fade_in = true;
        }
        else
        {
            is_fade_in = false;
        }
     }
     
     // color
     color = color_start;
     
     if (color_end == -1)
     {
        color_end = color_start;
     }
     
     if (!is_static && (color_start != color_end))
     {
        do_animate_color = true;
        
        if (color_duration > 0)
        {
            color_step = 1 / color_duration;
        }
        else
        {
            color_step = 0;
        }
     }
     
     
     do_init = false;
  }; // end of do_init
  


  // every frame ------------------------------------------------------
  delta = delta_expect / delta_time;
  //delta = delta_time / 1000000
  
  
  if (instance_exists(parent))
  {
      x = parent.x + offset_x;
      y = parent.y + offset_y;
      direction = parent.direction;
      
      if (match_parent_size)
      {
         scale_base_x = parent.width  / local_width;
         scale_base_y = parent.height / local_height;
      }
  }
  else
  {
      if (kill_with_parent)
      {
         do_destroy = true;
      }
  }
  
  // color
  if (!anim_color_done && do_animate_color)
  {
     color_mix += color_step;
     color = merge_colour(color_start, color_end, color_mix);
     
     if (color_mix > 1)
     {
        color_mix = 1;
        anim_color_done = true;
     }
  }
  
  // scale
  if (!anim_scale_done && do_animate_scale)
  {
      if (is_scale_up)
      {
         scale_x = scale_x + (scale_x_step * delta);
         scale_y = scale_y + (scale_y_step * delta);
         
         if (scale_x > scale_x_end)
         {
            scale_x = scale_x_end
            scale_y = scale_y_end
            anim_scale_done = true;
         }
      }
      else
      {
         scale_x = scale_x - (scale_x_step * delta);
         scale_y = scale_y - (scale_y_step * delta);
         
         if (scale_x < scale_x_end)
         {
            scale_x = scale_x_end
            scale_y = scale_y_end
            anim_scale_done = true;
         }
      }
  }
  image_xscale = scale_x * scale_base_x;
  image_yscale = scale_y * scale_base_y;
  
  
  // alpha
  if (!anim_alpha_done && do_animate_alpha)
  {
      if (is_fade_in)
      {
          alpha = alpha + (alpha_step * delta);
          
          if (alpha > alpha_end)
          {
             alpha = alpha_end;
             anim_alpha_done = true;
          }
      }
      else
      {
          alpha = alpha - (alpha_step * delta);
           
          if (alpha < alpha_end)
          {
             alpha = alpha_end;
             anim_alpha_done = true;
          }
      } 
  }
  
  if (anim_color_done)   {do_destroy = true;}
  if (anim_alpha_done)   {do_destroy = true;}
  if (anim_scale_done)   {do_destroy = true;}