var scr = "[obj_wheel:create] ";

// this object acts as the virual "wheel of fortune".
// note: it is not persistent, so each new roll there's a new random seed at play


enum STATE {rolling, spring_once, spring, settled_once, settled}
state              = STATE.settled

// the sprite dimensions used for the individual wheel slots
slot                = obj_slot
target_layer        = "Instances"
sprite              = spr_slotBg // important: y-origin need to be at sprite's center
sprite_h            = sprite_get_height(sprite)
sprite_w            = sprite_get_width(sprite)

// the y-coordinates of the start, end, and settle posiiton of the slot
initial_x   = x
settle_y    = y // starting y
initial_y   = y - (sprite_h / 2)
final_y     = y + (sprite_h / 2)

// anything related to physics
#region Physics
    // both starting impulse and friction are random
	initial_impulse     = random_range(40,50)
	friction_per_second = random_range(7,9)
	velocity            = 0
	
	// once the velocity is under a certain threshold,
	// we decrease the friction so it keep on going for linger
	friction_threshold  = 5
	friction_2          = friction_per_second / 5

	// spring solver settings
	spring_stiffness    = 50
	spring_damping      = 3
	spring_length       = 1
	spring_mass         = 1
#endregion

// anything related to the slots being displayed
#region Slots
slot1  = instance_create_layer(x, y - sprite_h, target_layer, slot)
slot2  = instance_create_layer(x, y		      , target_layer, slot)
slot3  = instance_create_layer(x ,y + sprite_h, target_layer, slot)

// the index of each entry as in the array in db_entries for faster access
slot1_index = -1
slot2_index = -1
slot3_index = -1
#endregion


// misc
control             = noone // will hold a reference to the control obect
roll_overs          = 0


// process variables and flags
first_run       = true;
do_init         = true
do_update_slots = true